.arm


.global convert_yuv_16
.global convert_yuv_rgb_8

.align 4
convert_yuv_16:

@ r0     = const uint16_t *src
@ r1     = uint32_t *dst
@ r2     = int width
@ lr     = return address


        vld1.16 {d16}, [r0]!        @ d16 = src[0-3]; src += 4
        mov r3, r2                  @ counter = width

        vmov.i16 d7, #(63 << 2)

        vshr.u16 d17, d16, #8       @ d17 = src[0-3] >> 8 -- b
        vshr.u16 d18, d16, #3       @ d18 = src[0-3] >> 3 -- g
        vshl.u16 d16, d16, #3       @ d16 = src[0-3] << 3 -- r

        vbic.i16 d17, #0x0007       @ d17 = (src[0-3] >> 8) & (31 << 3) -- b
        vbic.i16 d16, #0xff00       @ d16 = (src[0-3] << 3) & (31 << 3) -- r
        vand d18, d18, d7           @ d18 = (src[0-3] >> 3) & (63 << 2) -- g

        sub r3, r3, #4              @ counter -= 4

        vmov.i16 d1, #0x2f
        vmov.i16 d0, #32768
        vmov.i16 d2, #0xd1
        vorr.i16 d1, #0x6b00        @ d1 = 27439
        vmov.i16 d3, #0x32
        vorr.i16 d2, #0x1400        @ d2 = 5329
        vmov.i16 d4, #0xce
        vorr.i16 d3, #0x2b00        @ d3 = 11058
        vmov.i16 d5, #256           @ 256 * 32768 = 8388608
        vmov.i16 d6, #0xbd
        vorr.i16 d4, #0x5400        @ d4 = 21710
        vmov.i16 d30, #0x5d
        vorr.i16 d6, #0x7400        @ d1 = 29885
        vmov.i16 d31, #0xd0
        vorr.i16 d30, #0xc800       @ d30 = 51293; 3 * 51293 = 153879
        vorr.i16 d31, #0x6900       @ d31 = 27088; 27088 + 51293 = 78381

        vshr.u16 q10, q8, #5
        vshr.u16 d22, d18, #6

    1:
        vorr q8, q8, q10            @ b |= b >> 5; r |= r >> 5;
        vorr d18, d18, d22          @ g |= g >> 6

        vmull.u16 q14, d16, d0      @ q14 = (u32) r * 32768 -- v
        vmlsl.u16 q14, d18, d1      @ q14 -= (u32) g * 27439 -- v
        vmlsl.u16 q14, d17, d2      @ q14 -= (u32) b * 5329 -- v
        vmlal.u16 q14, d5, d0       @ q14 += 8388608 -- v

        vmull.u16 q13, d17, d0      @ q13 = (u32) b * 32768 -- u
        vmlsl.u16 q13, d18, d4      @ q13 -= (u32) g * 21710 -- u
        vmlsl.u16 q13, d16, d3      @ q13 -= (u32) r * 11058 -- u
        vmlal.u16 q13, d5, d0       @ q13 += 8388608 -- v

        vmull.u16 q12, d17, d6      @ q12 = (u32) b * 29885 -- y
        vmlal.u16 q12, d16, d30
        vmlal.u16 q12, d16, d31     @ q12 += (u32) r * 78381 -- y
        vmlal.u16 q12, d18, d30
        vmlal.u16 q12, d18, d30

        vmlal.u16 q12, d18, d30     @ q12 += (u32) g * 153879 -- y
        vtrn.8 q14, q13             @ q14 = (v + (u << 8)) << 16

        vld1.16 {d16}, [r0]!        @ d16 = src[0-3]; src += 4
        subS r3, r3, #4             @ counter -= 4

        vshr.u16 d17, d16, #8       @ d17 = src[0-3] >> 8 -- b
        vshr.u16 d18, d16, #3       @ d18 = src[0-3] >> 3 -- g
        vshl.u16 d16, d16, #3       @ d16 = src[0-3] << 3 -- r

        vbic.i32 q14, #0xff00
        vsri.32 q14, q12, #18       @ q14 = (u + (v << 8)) << 16 + y

        vbic.i16 d17, #0x0007       @ d17 = (src[0-3] >> 8) & (31 << 3) -- b
        vbic.i16 d16, #0xff00       @ d16 = (src[0-3] << 3) & (31 << 3) -- r

        vand d18, d18, d7           @ d18 = (src[0-3] >> 3) & (63 << 2) -- g
        vrev32.16 q14, q14          @ q14 = u + (v << 8) + (y << 16)

        vshr.u16 q10, q8, #5

        vshr.u16 d22, d18, #6
        vst1.32 {d28-d29}, [r1:64]! @ dst[0-3] = d28-d29; dst += 4

        bne 1b

        vorr q8, q8, q10            @ b |= b >> 5; r |= r >> 5;
        vorr d18, d18, d22          @ g |= g >> 6

        vmull.u16 q14, d16, d0      @ q14 = (u32) r * 32768 -- v
        vmlsl.u16 q14, d18, d1      @ q14 -= (u32) g * 27439 -- v
        vmlsl.u16 q14, d17, d2      @ q14 -= (u32) b * 5329 -- v
        vmlal.u16 q14, d5, d0       @ q14 += 8388608 -- v

        vmull.u16 q13, d17, d0      @ q13 = (u32) b * 32768 -- u
        vmlsl.u16 q13, d18, d4      @ q13 -= (u32) g * 21710 -- u
        vmlsl.u16 q13, d16, d3      @ q13 -= (u32) r * 11058 -- u
        vmlal.u16 q13, d5, d0       @ q13 += 8388608 -- v

        vmull.u16 q12, d17, d6      @ q12 = (u32) b * 29885 -- y
        vmlal.u16 q12, d16, d30
        vmlal.u16 q12, d16, d31     @ q12 += (u32) r * 78381 -- y
        vmlal.u16 q12, d18, d30
        vmlal.u16 q12, d18, d30
        vmlal.u16 q12, d18, d30     @ q12 += (u32) g * 153879 -- y

        vtrn.8 q14, q13             @ q14 = (v + (u << 8)) << 16

        vbic.i32 q14, #0xff00
        vsri.32 q14, q12, #18       @ q14 = (u + (v << 8)) << 16 + y

        vrev32.16 q14, q14          @ q14 = u + (v << 8) + (y << 16)

        vst1.32 {d28-d29}, [r1:64]! @ dst[0-3] = d28-d29; dst += 4



        sub r2, r1, r2, lsl #2      @ r2 = dst - width

        ldr r0, [r2]                @ r0 = origdst[0]

        vst1.32 {d29[1]}, [r1:32]   @ origdst[width] = origdst[width - 1]

        str r0, [r2, #-4]           @ origdst[-1] = origdst[0]
        bx lr

@ end procedure convert_yuv_16


convert_yuv_rgb_8:

@ r0     = const uint8_t *src
@ r1     = uint32_t *yuvdst
@ r2     = uint16_t *rgbdst
@ r3     = const uint16_t *pal
@ [sp]   = int width
@ lr     = return address

        ldr ip, [sp]                @ ip = width
        push {r4-r8}

        ldr r4, [r0], #4            @ r4 = src[0-3], src += 3
        vmov.i16 d7, #(63 << 2)

        vmov.i16 d1, #0x2f
        vmov.i16 d0, #32768
        vmov.i16 d2, #0xd1
        ubfx r7, r4, #0, #8         @ r7 = src[0]
        vorr.i16 d1, #0x6b00        @ d1 = 27439
        ubfx r6, r4, #8, #8         @ r6 = src[1]

        vmov.i16 d3, #0x32
        mov r7, r7, lsl #1          @ r7 = src[0] * 2
        vorr.i16 d2, #0x1400        @ d2 = 5329
        ubfx r5, r4, #16, #8        @ r5 = src[2]

        vmov.i16 d4, #0xce
        ldrh r7, [r3, r7]           @ r7 = pal[src[0]]
        vorr.i16 d3, #0x2b00        @ d3 = 11058
        mov r6, r6, lsl #1          @ r6 = src[1] * 2

        vmov.i16 d5, #256           @ 256 * 32768 = 8388608
        ldrh r6, [r3, r6]           @ r6 = pal[src[1]]
        vmov.i16 d6, #0xbd
        mov r4, r4, lsr #24         @ r4 = src[3]

        vorr.i16 d4, #0x5400        @ d4 = 21710
        mov r5, r5, lsl #1          @ r5 = src[2] * 2

        vmov.i16 d30, #0x5d
        ldrh r5, [r3, r5]           @ r5 = pal[src[2]]
        vorr.i16 d6, #0x7400        @ d1 = 29885
        mov r4, r4, lsl #1          @ r4 = src[3] * 2

        vmov.i16 d31, #0xd0
        ldrh r4, [r3, r4]           @ r4 = pal[src[3]]
        vorr.i16 d30, #0xc800       @ d30 = 51293; 3 * 51293 = 153879
        bfi r7, r6, #16, #16        @ r7 = pal[src[0]] | pal[src[1]] << 16

        vorr.i16 d31, #0x6900       @ d31 = 27088; 27088 + 51293 = 78381
        bfi r5, r4, #16, #16        @ r5 = pal[src[0]] | pal[src[1]] << 16

        vmov d16, r7, r5            @ d16 = pal[src[0-3]]
        mov r8, ip                  @ counter = width

        vst1.16 {d16}, [r2:64]!     @ rgbdst[0-3] = pal[src[0-3]]; rgbdst += 4

        vshr.u16 d17, d16, #8       @ d17 = pal[src[0-3]] >> 8 -- b
        vshr.u16 d18, d16, #3       @ d18 = pal[src[0-3]] >> 3 -- g
        vshl.u16 d16, d16, #3       @ d16 = pal[src[0-3]] << 3 -- r

        vbic.i16 d17, #0x0007       @ d17 = (pal[src[0-3]] >> 8) & (31 << 3) -- b
        vbic.i16 d16, #0xff00       @ d16 = (pal[src[0-3]] << 3) & (31 << 3) -- r
        vand d18, d18, d7           @ d18 = (pal[src[0-3]] >> 3) & (63 << 2) -- g

        sub r8, r8, #4              @ counter -= 4

        vshr.u16 q10, q8, #5
        vshr.u16 d22, d18, #6

    1:
        ldr r4, [r0], #4            @ r4 = src[0-3], src += 3
        vorr q8, q8, q10            @ b |= b >> 5; r |= r >> 5;
        vorr d18, d18, d22          @ g |= g >> 6

        vmull.u16 q14, d16, d0      @ q14 = (u32) r * 32768 -- v
        vmlsl.u16 q14, d18, d1      @ q14 -= (u32) g * 27439 -- v
        ubfx r7, r4, #0, #8         @ r7 = src[0]
        vmlsl.u16 q14, d17, d2      @ q14 -= (u32) b * 5329 -- v
        ubfx r6, r4, #8, #8         @ r6 = src[1]
        vmlal.u16 q14, d5, d0       @ q14 += 8388608 -- v
        mov r7, r7, lsl #1          @ r7 = src[0] * 2

        vmull.u16 q13, d17, d0      @ q13 = (u32) b * 32768 -- u
        ldrh r7, [r3, r7]           @ r7 = pal[src[0]]
        vmlsl.u16 q13, d18, d4      @ q13 -= (u32) g * 21710 -- u
        mov r6, r6, lsl #1          @ r6 = src[1] * 2
        vmlsl.u16 q13, d16, d3      @ q13 -= (u32) r * 11058 -- u
        ldrh r6, [r3, r6]           @ r6 = pal[src[1]]
        vmlal.u16 q13, d5, d0       @ q13 += 8388608 -- v
        ubfx r5, r4, #16, #8        @ r5 = src[2]

        vmull.u16 q12, d17, d6      @ q12 = (u32) b * 29885 -- y
        mov r4, r4, lsr #24         @ r4 = src[3]
        vmlal.u16 q12, d16, d30
        mov r5, r5, lsl #1          @ r5 = src[2] * 2
        vmlal.u16 q12, d16, d31     @ q12 += (u32) r * 78381 -- y
        ldrh r5, [r3, r5]           @ r5 = pal[src[2]]
        vmlal.u16 q12, d18, d30
        mov r4, r4, lsl #1          @ r4 = src[3] * 2
        vmlal.u16 q12, d18, d30
        ldrh r4, [r3, r4]           @ r4 = pal[src[3]]

        vmlal.u16 q12, d18, d30     @ q12 += (u32) g * 153879 -- y
        bfi r7, r6, #16, #16        @ r7 = pal[src[0]] | pal[src[1]] << 16
        vtrn.8 q14, q13             @ q14 = (v + (u << 8)) << 16
        bfi r5, r4, #16, #16        @ r5 = pal[src[0]] | pal[src[1]] << 16

        subS r8, r8, #4             @ counter -= 4
        vmov d16, r7, r5            @ d16 = pal[src[0-3]]

        vst1.16 {d16}, [r2:64]!     @ rgbdst[0-3] = pal[src[0-3]]; rgbdst += 4

        vshr.u16 d17, d16, #8       @ d17 = pal[src[0-3]] >> 8 -- b
        vshr.u16 d18, d16, #3       @ d18 = pal[src[0-3]] >> 3 -- g
        vshl.u16 d16, d16, #3       @ d16 = pal[src[0-3]] << 3 -- r

        vbic.i32 q14, #0xff00
        vsri.32 q14, q12, #18       @ q14 = (u + (v << 8)) << 16 + y

        vbic.i16 d17, #0x0007       @ d17 = (pal[src[0-3]] >> 8) & (31 << 3) -- b
        vbic.i16 d16, #0xff00       @ d16 = (pal[src[0-3]] << 3) & (31 << 3) -- r

        vand d18, d18, d7           @ d18 = (pal[src[0-3]] >> 3) & (63 << 2) -- g
        vrev32.16 q14, q14          @ q14 = u + (v << 8) + (y << 16)

        vshr.u16 q10, q8, #5

        vshr.u16 d22, d18, #6
        vst1.32 {d28-d29}, [r1:64]! @ yuvdst[0-3] = d28-d29; dst += 4

        bne 1b

        vorr q8, q8, q10            @ b |= b >> 5; r |= r >> 5;
        vorr d18, d18, d22          @ g |= g >> 6

        vmull.u16 q14, d16, d0      @ q14 = (u32) r * 32768 -- v
        vmlsl.u16 q14, d18, d1      @ q14 -= (u32) g * 27439 -- v
        vmlsl.u16 q14, d17, d2      @ q14 -= (u32) b * 5329 -- v
        vmlal.u16 q14, d5, d0       @ q14 += 8388608 -- v

        vmull.u16 q13, d17, d0      @ q13 = (u32) b * 32768 -- u
        vmlsl.u16 q13, d18, d4      @ q13 -= (u32) g * 21710 -- u
        vmlsl.u16 q13, d16, d3      @ q13 -= (u32) r * 11058 -- u
        vmlal.u16 q13, d5, d0       @ q13 += 8388608 -- v

        vmull.u16 q12, d17, d6      @ q12 = (u32) b * 29885 -- y
        vmlal.u16 q12, d16, d30
        vmlal.u16 q12, d16, d31     @ q12 += (u32) r * 78381 -- y
        vmlal.u16 q12, d18, d30
        vmlal.u16 q12, d18, d30
        vmlal.u16 q12, d18, d30     @ q12 += (u32) g * 153879 -- y

        vtrn.8 q14, q13             @ q14 = (v + (u << 8)) << 16

        vbic.i32 q14, #0xff00
        vsri.32 q14, q12, #18       @ q14 = (u + (v << 8)) << 16 + y

        vrev32.16 q14, q14          @ q14 = u + (v << 8) + (y << 16)

        vst1.32 {d28-d29}, [r1:64]! @ yuvdst[0-3] = d28-d29; dst += 4


        sub ip, r1, ip, lsl #2      @ ip = yuvdst - width

        ldr r0, [ip]                @ r0 = origyuvdst[0]

        vst1.32 {d29[1]}, [r1:32]   @ origyuvdst[width] = origyuvdst[width - 1]

        str r0, [ip, #-4]           @ origyuvdst[-1] = origyuvdst[0]

        pop {r4-r8}
        bx lr

@ end procedure convert_yuv_rgb_8

